/* Copyright (c) 2013-2015, Colfax International. All Right Reserved.
This file, labs/2/2.04-offload-asynchronous/solutions/matrix.cc,
is a part of Supplementary Code for Practical Exercises for the handbook
"Parallel Programming and Optimization with Intel Xeon Phi Coprocessors",
2nd Edition -- 2015, Colfax International,
ISBN 9780988523401 (paper), 9780988523425 (PDF), 9780988523432 (Kindle).
Redistribution or commercial usage without written permission 
from Colfax International is prohibited.
Contact information can be found at http://colfax-intl.com/     */



#include <cstdio>
#include <cstdlib>
#include <omp.h>

int main(){

  const int iterMax = 3;
  const int m=10, n=100000;
  double b[n], c_target[n], c_host[n];
  double * A = (double*) malloc(sizeof(double)*n*m);
  int sig=1;

  // Cilk Plus array notation
 // for (int i=0; i<m*n; i++)
  A[0:n*m]=2.0; //(double)n;
  c_target[:]=0.0;

  printf("initilization c_target[909] = %f\n", c_target[909]);

#pragma offload target(mic:1) in (A:length(n*m))  inout(b, c_target: alloc_if(1) free_if(1))

//#pragma offload target(mic:1) signal(&sig) in (A:length(n*m)) \
 inout(b: alloc_if(1) free_if(1)) inout(c_target:alloc_if(0) free_if(1))
{    b[:] = (double) 2; //iter;
     c_target[:]=10.0/4; // results calculated on the coprocessor
}
printf("before sync with Phi: on host c_target[909] = %f\n", c_target[909]);

//#pragma offload_wait target(mic:1) wait(&sig)
printf("after sync with Phi: on host c_target[909] = %f\n", c_target[909]);

printf("bye\n");
/*
#pragma offload target(mic:1) nocopy(A) // : free_if(iter==iterMax-1))//	\
//    signal(A)
    {
      // running the calculation on the coprocessor asynchronously
      for ( int i = 0 ; i < m ; i++)
        for ( int j = 0 ; j < n ; j++)
          c_target[i] += A[i*n+j] * b[j];

	// printf("on MIC c_target[99] = %d\n", c_target[99]);
    }

	printf("on host c_target[99] = %d\n", c_target[99]);
    // the following code is running on the host asynchronously 
  /*  for ( int i = 0 ; i < m ; i++)
      for ( int j = 0 ; j < n ; j++)
        c_host[i] += A[i*n+j] * b[j];

    // sync before proceeding
//#pragma offload_wait target(mic:1) wait(A)

    double norm = 0.0;
    for ( int i = 0 ; i < m ; i++)
      norm += (c_target[i] - c_host[i])*(c_target[i] - c_host[i]);
    if (norm > 1e-10)
      printf("ERROR! In iter %i, the norm is %e:\n", iter, norm);
    else
      printf("Yep, iter %i is good!\n", iter);
 // }
 // */
}
