// ****************************************************************************
// offload simple procedures with no complications
// compile with: icc -openmp
//
// NOTE: the (seemingly) "extra" set of parens needed when using the
//       __attribute__ syntax!
//
// djames (at) tacc.utexas.edu
// 29 Sep 2013
// ****************************************************************************

#include <stdio.h>
#include <omp.h>

// ------------------------------------------------------------------

//int  successor( int   m );
//void increment( int* pm );

//__declspec( target(mic) ) int  successor( int   m );
//__declspec( target(mic) ) void increment( int* pm );

__attribute__( ( target(mic) ) ) int  successor( int m  );
__attribute__( ( target(mic) ) ) void increment(   int* m );

// ------------------------------------------------------------------
int main( void ) {

    int i;
    double tstart, tend;

    tstart = omp_get_wtime();
    #pragma offload target(mic)    
      {
        i = successor( 123 );
        increment( &i );
      }  
    tend = omp_get_wtime();

    printf("\n Off04proc completed in %9.5f seconds.", tend-tstart );
 
    printf( "\n\t i = %d \n\n", i );

    return 0;

}

// ------------------------------------------------------------------

int successor( int m )  {
  return m+1;    // ++m works and is more compact, but seems cavalier
}

// ------------------------------------------------------------------

void increment(   int* pm )  {
  (*pm)++;
  return;
}
