! ******************************************************************************
! offload simple procedures
! compile with: ifort -openmp 
!
! One procedure is in a module (and only one attributes directive is required).
! The other is not in a module; you need an attributes directive for the 
! declaration, and another in every subprogram that calls the procedure.
!
! ifort doesn't seem to be very particular about when and where you
! apply the attributes directive.
!
! djames (at) tacc.utexas.edu
! 29 Sep 2013
! ******************************************************************************

module utils

  contains

    !dir$ attributes offload:mic :: increment
    subroutine increment( m )
      m = m + 1 
    end subroutine increment

end module utils

! -------------------------------------------------------------------

!dir$ attributes offload:mic :: successor
integer function successor( m )
  integer, intent(in)    :: m
  successor = m + 1
end function successor

! -------------------------------------------------------------------

program main

  use utils
  implicit  none

  integer :: i
  integer :: successor
  !dir$ attributes offload:mic :: successor

  !dir$ offload target(mic)
    i = successor(123)

  !dir$ offload target(mic)
    call increment(i)

  print*, "   i = ", i

end program
