// ****************************************************************************
// offload a very simple block of code
// compile with: icc -openmp
//
// See comments in f90 equivalent; the Fortran compiler is a bit picky about
// what one-liners it allows below an offload directive.  C isn't so picky.
//
// djames (at) tacc.utexas.edu
// 29 Sep 2013
// ****************************************************************************

#include <stdio.h>
#include <omp.h>

int main( void )  {

  int totalProcs;
  int maxThreads;

  #pragma offload target(mic)
    {  // begin offload block
      totalProcs = omp_get_num_procs();
      maxThreads = omp_get_max_threads();
    }  // end offload block

  printf( "   total procs: %d\n", totalProcs );
  printf( "   max threads: %d\n", maxThreads );

  return 0;

}
